/*
    MSGLIB - a message handling library
    Copyright (C) 1995,1997  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/*
    utility for the message handling library
    Copyright (C) 1995  Steffen Kaiser

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*/
/* $RCSfile: MSGMAKE.C $
   $Locker:  $	$Name:  $	$State: Exp $

	Makefile generator for Micro-C, because it does not support
	multiple files on the command line.

	Usage: msgMake [{responseFile}...] >Makefile

	If responseFile is omitted, stdin is read.
	The responseFile is a whitespace delimited list of source files,
	msgMake creates an Makefile for Borland's make utility.

	There will be no error reporting at all.

*/

#include <stdio.h>
#ifndef _MICROC_
#include <string.h>
#endif
#include <freedos.h>

#ifndef lint
static char const rcsid[] = 
	"$Id: MSGMAKE.C 1.1 1998/01/14 08:31:59 ska Exp $";
#endif

/*
print ".c.obj:\n\t\$(MCDIR)\\cc \$** -flop e=errlist _MICROC_=1 t=q\n\n";
$o = 'all :';
while(<>) {
	chop;
	$n = $_;
	s/\.c/\.obj/;
	if(length($o) + length($_) > 75) {
		$obj .= $o . " \\\n";
		$o = '   ';
	}
	$o .= " $_";
}

print "\n\n" . $obj . $o . "\n";	*/

#define BUF 4096
char buf[BUF];
char o[BUF] = "all :";
const char obj[] = ".obj";

void handle(FILE *fin)
{	char *s, *p;

	while(fgets(buf, BUF, fin)) {
		strlwr(buf);
		if(s = strtok(buf, " \t\n")) do {
			if(*s && (p = strstr(s, ".c"))) {
				*p = NUL;
				if(strlen(o) + strlen(s) > 77 - sizeof(obj)) {
#ifdef _MICROC_		/* There is still a bug in the MCLIB */
					stpcat(o, " \\");
					puts(o);
#else
					puts(strcat(o, " \\"));
#endif
					stpcpy(o, "   ");
				}
				stpcpy(stpcpy(stpcat(o, " "), s), obj);
			}
		} while(s = strtok(NULL, " \t\n"));
	}
}

int main(int argc, char **argv)
{	FILE *fp;

	puts("CFLAGS !:= $(CFLAGS:s/-flop/-flp/)\n");

	if(argc == 1)	/* clean up from stdin */
		handle(stdin);
	else while(*++argv)
		if(fp = fopen(*argv, "rt")) {
			handle(fp);
			fclose(fp);
		}

	puts(o);
#ifndef _MICROC_
	return 0;
#endif
}
